/* 
   INSTALL.CMD

   IPF Editor Installation Program (C) 1993 Perez Computing Services
   Allows target drive to be specified on command line.
*/
arg Temp

trace off

/* Initialize REXX utility functions */
call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

/* Strip out any colons */
PARSE VALUE Temp WITH TargetDrive 2

if TargetDrive = "" then do
say 'Enter the drive letter to install the IPF Editor on and press <ENTER>:'
pull TargetDrive
end  /* Do */

info = SysDriveInfo( TargetDrive )
parse VAR info cLetter lDiskFree lTotalDisk
if lDiskFree < 700000 then do
say 'Drive 'TargetDrive' has only 'lDiskFree' bytes free and the IPF Editor'
say ' requires at least 700,000 bytes free to install correctly.'
exit
end
else
say 'Drive 'TargetDrive' has enough space ('lDiskFree') to install the IPF Editor'

if info = "" then do
say '"'TargetDrive'" is an invalid drive, please restart IPF Editor Installation program.'
exit
end

say 'Installing the PCS IPF Editor onto drive 'TargetDrive'...'



call Loadfiles

SAY 'Creating IPF Editor Folder...'

/* Create IPF Editor Information folder */
classname='WPFolder'
title='IPF Editor^Shareware Version'
location='<WP_DESKTOP>'
setup='OBJECTID=<IPFEDIT_SW_FOLDER>;'||,
      'ICONFILE=IPFEDIT.ICO;'
Call BldObj

SAY 'Creating IPF Editor Program Objects...'

classname='WPProgram'
title='IPF Editor^Shareware Version'
location='<IPFEDIT_SW_FOLDER>'
setup='OBJECTID=<IPFEDITOR_SW_PGM>;'||,
      'EXENAME='TargetDrive':\IPFEDIT\IPFEDIT.EXE;'||,
      'STARTUPDIR='TargetDrive':\IPFEDIT;'||,
      'PARAMETERS= ;'||,
      'ICONPOS=8,8;'||,
      'PROGTYPE=PM;'
Call BldObj


classname='WPProgram'
title='IPF Editor^License Agreement'
location='<IPFEDIT_SW_FOLDER>'
setup='OBJECTID=<IPFEDITOR_SW_LICENSE>;'||,
      'EXENAME=VIEW.EXE;'||,
      'PARAMETERS='TargetDrive':\IPFEDIT\LICENSE.INF;'||,
      'STARTUPDIR='TargetDrive':\IPFEDIT;'||,
      'ICONPOS=34,8;'||,
      'PROGTYPE=PM;'
Call BldObj

classname='WPProgram'
title='IPF Editor^Online Reference'
location='<IPFEDIT_SW_FOLDER>'
setup='OBJECTID=<IPFEDITOR_SW_REFERENCE>;'||,
      'EXENAME=VIEW.EXE;'||,
      'PARAMETERS='TargetDrive':\IPFEDIT\IPFEDOC.INF;'||,
      'STARTUPDIR='TargetDrive':\IPFEDIT;'||,
      'ICONPOS=48,8;'||,
      'PROGTYPE=PM;'
Call BldObj

classname='WPProgram'
title='IPF Editor^Registration Form'
location='<IPFEDIT_SW_FOLDER>'
setup='OBJECTID=<IPFEDITOR_SW_REGISTRATION>;'||,
      'EXENAME=E.EXE;'||,
      'PARAMETERS='TargetDrive':\IPFEDIT\IPFEDIT.REG;'||,
      'STARTUPDIR='TargetDrive':\IPFEDIT;'||,
      'ICONPOS=62,8;'||,
      'PROGTYPE=PM;'
Call BldObj

classname='WPProgram'
title='IPF Editor^Sample Online Document'
location='<IPFEDIT_SW_FOLDER>'
setup='OBJECTID=<IPFEDITOR_SAMPLE_ONDOC>;'||,
      'EXENAME=VIEW.EXE;'||,
      'PARAMETERS='TargetDrive':\IPFEDIT\DSAMPLE\SHAKESPR.INF;'||,
      'STARTUPDIR='TargetDrive':\IPFEDIT\DSAMPLE;'||,
      'ICONPOS=76,8;'||,
      'PROGTYPE=PM;'
Call BldObj

classname='WPProgram'
title='IPF Editor^Sample C Application
Created using
'TargetDrive':\IPFEDIT\CSAMPLE\IFPEDEMO.MAK.'
location='<IPFEDIT_SW_FOLDER>'
setup='OBJECTID=<IPFEDITOR_SW_SMPLCAPP>;'||,
      'EXENAME='TargetDrive':\IPFEDIT\CSAMPLE\IPFEDEMO.EXE;'||,
      'PARAMETERS= ;'||,
      'STARTUPDIR='TargetDrive':\IPFEDIT\CSAMPLE;'||,
      'ICONPOS=98,8;'||,
      'PROGTYPE=PM;'
Call BldObj

/* Do README last so focus set to it when folder opened */
classname='WPProgram'
title='IPF Editor^Readme File'
location='<IPFEDIT_SW_FOLDER>'
setup='OBJECTID=<IPFEDITOR_SW_README>;'||,
      'EXENAME=VIEW.EXE;'||,
      'PARAMETERS='TargetDrive':\IPFEDIT\README.INF;'||,
      'STARTUPDIR='TargetDrive':\IPFEDIT;'||,
       'ICONPOS=20,8;'||,
      'PROGTYPE=PM;'
Call BldObj


SAY ''
SAY ''
SAY 'IPF Editor installation complete.  Please see the contents of the'
SAY ' IPF Editor Folder to try out the IPF Editor.  Please view the'
SAY ' README.INF file for the latest information about the IPF Editor.'
SAY ''
SAY 'You may wish to edit your CONFIG.SYS to add the 'TargetDrive':\IPFEDIT subdirectory'
SAY ' to the HELP, LIBPATH, and BOOKSHELF statements.'
SAY ''
SAY 'IPF Editor (C) 1993 Perez Computing Systems'

Exit



/* Build Object */
BldObj:
result = SysCreateObject(classname, title, location, setup, 'U')
Return

/* Load all files from current to target drive */
LoadFiles:
Say 'Creating 'TargetDrive':\IPFEDIT directory...'
call SysMkDir TargetDrive':\IPFEDIT'
Say 'Creating 'TargetDrive':\IPFEDIT\CSAMPLE directory...'
call SysMkDir TargetDrive':\IPFEDIT\CSAMPLE'
Say 'Creating 'TargetDrive':\IPFEDIT\DSAMPLE directory...'
call SysMkDir TargetDrive':\IPFEDIT\DSAMPLE'
SAY 'Copying IPF Editor files to 'TargetDrive':\IPFEDIT...'
'@copy IPFEDIT.HLP ' TargetDrive':\IPFEDIT >NUL'
'@copy IPFEDIT.EXE ' TargetDrive':\IPFEDIT >NUL'
'@copy BITMAP.DLL ' TargetDrive':\IPFEDIT >NUL'
'@copy *.INF ' TargetDrive':\IPFEDIT >NUL'
'@copy README.TXT ' TargetDrive':\IPFEDIT >NUL'
'@copy IPFEDIT.REG ' TargetDrive':\IPFEDIT >NUL'
'@copy *.ICO ' TargetDrive':\IPFEDIT >NUL'
SAY 'Copying IPF Editor Sample Online Documentation files to 'TargetDrive':\IPFEDIT\DSAMPLE...'
'@copy shakespr.* ' TargetDrive':\IPFEDIT\DSAMPLE >NUL'
'@copy 12thnite.* ' TargetDrive':\IPFEDIT\DSAMPLE >NUL'
SAY 'Copying IPF Editor Sample C Application files to 'TargetDrive':\IPFEDIT\CSAMPLE...'
'@copy ipfedemo.* ' TargetDrive':\IPFEDIT\CSAMPLE >NUL'
'@copy ipfed_mn.ipf ' TargetDrive':\IPFEDIT\CSAMPLE >NUL'
'@copy ipfedhlp.c ' TargetDrive':\IPFEDIT\CSAMPLE >NUL'
'@copy ipfedhlp.h ' TargetDrive':\IPFEDIT\CSAMPLE >NUL'
'@copy ipfedhlp.rc ' TargetDrive':\IPFEDIT\CSAMPLE >NUL'
'@copy ipfedhlp.obj ' TargetDrive':\IPFEDIT\CSAMPLE >NUL'
Return




